3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
17 die "Usage: $0 [--template=<template_directory>] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [--depth <n>] [-n] <repo> [<dir>]"
21 (cd "$1" && (cd .git ; pwd)) 2> /dev/null
24 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
29 # $1 = Remote, $2 = Local
30 curl -nsfL $curl_extra_args "$1" >"$2"
34 # $1 - remote, $2 - local
36 clone_tmp="$GIT_DIR/clone-tmp" &&
37 mkdir -p "$clone_tmp" || exit 1
38 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
39 "`git-config --bool http.noEPSV`" = true ]; then
40 curl_extra_args="${curl_extra_args} --disable-epsv"
42 http_fetch "$1/info/refs" "$clone_tmp/refs" ||
43 die "Cannot get remote repository information.
44 Perhaps git-update-server-info needs to be run there?"
45 while read sha1 refname
47 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
52 yes,* | ,heads/* | ,tags/*) ;;
55 if test -n "$use_separate_remote" &&
56 branch_name=`expr "z$name" : 'zheads/\(.*\)'`
58 tname="remotes/$origin/$branch_name"
62 git-http-fetch -v -a -w "$tname" "$name" "$1/" || exit 1
63 done <"$clone_tmp/refs"
65 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
66 rm -f "$GIT_DIR/REMOTE_HEAD"
85 *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
86 *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
88 *,--na|*,--nak|*,--nake|*,--naked|\
89 *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
90 *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
91 *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
92 local_shared=yes; use_local=yes ;;
93 1,--template) usage ;;
95 shift; template="--template=$1" ;;
98 *,-q|*,--quiet) quiet=-q ;;
99 *,--use-separate-remote) ;;
100 *,--no-separate-remote)
101 die "clones are always made with separate-remote layout" ;;
102 1,--reference) usage ;;
104 shift; reference="$1" ;;
106 reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
107 *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
112 die "'$2' is not suitable for an origin name"
114 git-check-ref-format "heads/$2" ||
115 die "'$2' is not suitable for a branch name"
116 test -z "$origin_override" ||
117 die "Do not give more than one --origin options."
121 1,-u|1,--upload-pack) usage ;;
122 *,-u|*,--upload-pack)
124 upload_pack="--upload-pack=$1" ;;
126 upload_pack=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
140 die 'you must specify a repository to clone.'
142 # --bare implies --no-checkout and --no-separate-remote
143 if test yes = "$bare"
145 if test yes = "$origin_override"
147 die '--bare and --origin $origin options are incompatible.'
158 # Turn the source into an absolute path if
160 if base=$(get_repo_base "$repo"); then
166 # Try using "humanish" part of source repo if user didn't specify one
167 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
168 [ -e "$dir" ] && die "destination directory '$dir' already exists."
170 D=$(cd "$dir" && pwd) &&
171 trap 'err=$?; cd ..; rm -rf "$D"; exit $err' 0
177 esac && export GIT_DIR && git-init ${template+"$template"} || usage
179 if test -n "$reference"
182 if test -d "$reference"
184 if test -d "$reference/.git/objects"
186 ref_git="$reference/.git"
187 elif test -d "$reference/objects"
192 if test -n "$ref_git"
194 ref_git=$(cd "$ref_git" && pwd)
195 echo "$ref_git/objects" >"$GIT_DIR/objects/info/alternates"
197 GIT_DIR="$ref_git" git for-each-ref \
198 --format='%(objectname) %(*objectname)'
203 git update-ref "refs/reference-tmp/$a" "$a"
205 git update-ref "refs/reference-tmp/$b" "$b"
208 die "reference repository '$reference' is not a local directory."
212 rm -f "$GIT_DIR/CLONE_HEAD"
214 # We do local magic only when the user tells us to.
215 case "$local,$use_local" in
217 ( cd "$repo/objects" ) ||
218 die "-l flag seen but repository '$repo' is not local."
220 case "$local_shared" in
222 # See if we can hardlink and drop "l" if not.
223 sample_file=$(cd "$repo" && \
224 find objects -type f -print | sed -e 1q)
226 # objects directory should not be empty since we are cloning!
227 test -f "$repo/$sample_file" || exit
230 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
234 rm -f "$GIT_DIR/objects/sample" &&
236 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
239 mkdir -p "$GIT_DIR/objects/info"
240 echo "$repo/objects" >> "$GIT_DIR/objects/info/alternates"
243 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
250 *) die "shallow over rsync not supported" ;;
252 rsync $quiet -av --ignore-existing \
253 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
255 # Look at objects/info/alternates for rsync -- http will
256 # support it natively and git native ones will do it on the
257 # remote end. Not having that file is not a crime.
258 rsync -q "$repo/objects/info/alternates" \
259 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
260 rm -f "$GIT_DIR/TMP_ALT"
261 if test -f "$GIT_DIR/TMP_ALT"
264 . git-parse-remote &&
265 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
268 case "$alt" in 'bad alternate: '*) die "$alt";; esac
270 '') echo >&2 "Getting alternate: $alt" ;;
272 rsync $quiet -av --ignore-existing \
273 --exclude info "$alt" "$GIT_DIR/objects" || exit
275 rm -f "$GIT_DIR/TMP_ALT"
277 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
279 https://*|http://*|ftp://*)
282 *) die "shallow over http or ftp not supported" ;;
284 if test -z "@@NO_CURL@@"
286 clone_dumb_http "$repo" "$D"
288 die "http transport not supported, rebuild Git with curl support"
292 case "$upload_pack" in
293 '') git-fetch-pack --all -k $quiet $depth "$repo" ;;
294 *) git-fetch-pack --all -k $quiet "$upload_pack" $depth "$repo" ;;
295 esac >"$GIT_DIR/CLONE_HEAD" ||
296 die "fetch-pack from '$repo' failed."
301 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
303 if test -f "$GIT_DIR/CLONE_HEAD"
305 # Read git-fetch-pack -k output and store the remote branches.
306 if [ -n "$use_separate_remote" ]
308 branch_top="remotes/$origin"
319 destname="REMOTE_HEAD" ;;
321 destname="refs/$branch_top/${name#refs/heads/}" ;;
323 destname="refs/$tag_top/${name#refs/tags/}" ;;
327 git-update-ref -m "clone: from $repo" "$destname" "$sha1" ""
328 done < "$GIT_DIR/CLONE_HEAD"
333 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
335 # a non-bare repository is always in separate-remote layout
336 remote_top="refs/remotes/$origin"
337 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
340 # Uh-oh, the remote told us (http transport done against
341 # new style repository with a symref HEAD).
342 # Ideally we should skip the guesswork but for now
343 # opt for minimum change.
344 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
345 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
349 # The name under $remote_top the remote HEAD seems to point at.
352 test -f "$GIT_DIR/$remote_top/master" && echo "master"
353 cd "$GIT_DIR/$remote_top" &&
354 find . -type f -print | sed -e 's/^\.\///'
359 test t = $done && continue
360 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
361 if test "$head_sha1" = "$branch_tip"
370 # Write out remote.$origin config, and update our "$head_points_at".
371 case "$head_points_at" in
373 # Local default branch
374 git-symbolic-ref HEAD "refs/heads/$head_points_at" &&
376 # Tracking branch for the primary branch at the remote.
377 origin_track="$remote_top/$head_points_at" &&
378 git-update-ref HEAD "$head_sha1" &&
381 git-config remote."$origin".url "$repo" &&
383 # Set up the mappings to track the remote branches.
384 git-config remote."$origin".fetch \
385 "+refs/heads/*:$remote_top/*" '^$' &&
386 rm -f "refs/remotes/$origin/HEAD"
387 git-symbolic-ref "refs/remotes/$origin/HEAD" \
388 "refs/remotes/$origin/$head_points_at" &&
390 git-config branch."$head_points_at".remote "$origin" &&
391 git-config branch."$head_points_at".merge "refs/heads/$head_points_at"
394 case "$no_checkout" in
396 test "z$quiet" = z && v=-v || v=
397 git-read-tree -m -u $v HEAD HEAD
400 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"